﻿using System.Linq;

namespace _2011_04_12_2011_04_13_Praktikum
{
    class DataSeries
    {
        string title;
        double[] xValues, yValues;
        double minX, maxX, minY, maxY;

        public DataSeries(string path)
        {
            // To do: Hier sollten ein paar Exceptions gefangen werden; das war aber noch nicht dran.
            string[] lines = System.IO.File.ReadAllLines(path);
            title = lines[0];
            xValues = new double[lines.Length-1];
            yValues = new double[lines.Length-1];
            for (int i = 1; i < lines.Length; i++)
			{
			    string[] parts = lines[i].Split(';');
                xValues[i-1] = double.Parse(parts[0]);
                yValues[i-1] = double.Parse(parts[1]);
			}
            minX = xValues.Min();
            maxX = xValues.Max();
            minY = yValues.Min();
            maxY = yValues.Max();
        }

        public override string ToString()
        {
            return title;
        }

        public double MinX
        {
            get { return minX; }
        }

        public double MaxX
        {
            get { return maxX; }
        }

        public double MinY
        {
            get { return minY; }
        }

        public double MaxY
        {
            get { return maxY; }
        }

        public System.Windows.Shapes.Polyline BuildPolyline(double width, double height)
        {
            // To do: Max könnte gleich Min sein!
            double scaleX = width / (MaxX - MinX);
            double scaleY = height / (MaxY - MinY);
            System.Windows.Shapes.Polyline polyline = new System.Windows.Shapes.Polyline();
            polyline.StrokeThickness = 2.0;
            polyline.Stroke = System.Windows.Media.Brushes.Red;
            for (int i = 0; i < xValues.Length; i++)
			{
                // Die y-Achse zeigt auf dem Bildschirm nach unten!
			    polyline.Points.Add(new System.Windows.Point(scaleX*(xValues[i]-MinX), scaleY*(MaxY-yValues[i])));
			}
            return polyline;
        }
    }
}
